
;; Copyright (c) 2013 Francois Fleuret
;; Written by Francois Fleuret <francois@fleuret.org>
;;
;; This file is part of mymail.
;;
;; mymail is free software: you can redistribute it and/or modify it
;; under the terms of the GNU General Public License version 3 as
;; published by the Free Software Foundation.
;;
;; mymail is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with mymail.  If not, see <http://www.gnu.org/licenses/>.

(add-to-list 'recentf-exclude "/tmp/mymail-vm-.*\.mbox")

(defcustom mymail/default-search-request ""
  "Default request to add to any search"
  :type 'string)

(defun mymail/vm-visit-folder (param)
  (interactive
   (list (read-string "mymail: " nil 'mymail-vm-history)))

  (let ((n 1)
        (mbox-name nil)

        (search-args

         (apply 'nconc
          (mapcar
           (lambda (searche-request)
             (if (not (string= searche-request ""))
                 (list "-s" searche-request)))
           (split-string (concat param "," mymail/default-search-request) ",")
           )))

        )

    (while (get-file-buffer (setq mbox-name (format "/tmp/mymail-vm-%d.mbox" n)))
      (setq n (+ n 1)))

    (if (= (apply 'call-process
                  (nconc (list "mymail" nil nil nil
                               "--output" mbox-name
                               "--default-search" "p")
                         search-args))
           0)
        (vm-visit-folder mbox-name t)
      (message "mymail failed"))
  ))
